var http = require('http'),
    url = require('url');

var version = '0.1.0';
var apiServer = 'api.hastests.com';
var port = 80;

var run = function(program, callback) {
    var qs = url.format({query: {q: program}});
    var req = http.request({hostname: apiServer,
                            port: port,
                            path: '/data'+qs,
                            headers: {'User-Agent': 'hastests-node '+version}},
                            function (res) {
                                res.setEncoding('utf8');
                                if (res.statusCode != 200) {
                                    callback(new Error("Server error: "
                                                       +res.statusCode));
                                    return;
                                }
                                res.on('data', function(data) {
                                    var d = JSON.parse(data);
                                    if (d.error) {
                                        var msg = 'on line '+d.error.line+
                                                  ': '+d.error.message;
                                        callback(new Error(msg));
                                    } else {
                                        callback(null, d);
                                    }
                                });
                            });
    req.on('error', function(e) {
        callback(e, null);
    });
    req.end();
};

exports.run = run;
